/**
 * This file was auto-generated by openapi-typescript.
 * Do not make direct changes to the file.
 */


export type paths = {
  "/api/bookings/": {get: operations["bookings_list"];};
  "/api/bookings/recent/": {get: operations["bookings_recent_list"];};
  "/api/bookings/stale/": {get: operations["bookings_stale_list"];};
  "/api/budgets/": {
    get: operations["budgets_list"];
    post: operations["budgets_create"];
  };
  "/api/budgets/{id}/": {
    get: operations["budgets_retrieve"];
    patch: operations["budgets_partial_update"];
  };
  "/api/budgets/potential_parents/": {get: operations["budgets_potential_parents_list"];};
  "/api/misc/logs/": {get: operations["misc_logs_list"];};
  "/api/misc/stats/": {get: operations["misc_stats_retrieve"];};
  "/api/offers/{id}/": {patch: operations["offers_partial_update"];};
  "/api/requesters/": {get: operations["requesters_list"];};
  "/api/requesters/{id}/": {get: operations["requesters_retrieve"];};
  "/api/requests/{id}/": {delete: operations["requests_destroy"];};
  "/api/requests/recent/": {get: operations["requests_recent_list"];};
  "/api/requests/stale/": {get: operations["requests_stale_list"];};
  "/api/schema/": {
    /**
     * @description OpenApi3 schema for this API. Format can be selected via content negotiation.
     * 
     * - YAML: application/vnd.oai.openapi
     * - JSON: application/vnd.oai.openapi+json
     */
    get: operations["schema_retrieve"];
  };
  "/api/users/new_sso_user/": {post: operations["users_new_sso_user_create"];};
  "/api/whoami/": {get: operations["whoami_retrieve"];};
  "/api/year/{year}/": {get: operations["year_retrieve"];};
  "/api/year/{year}/fond/{id}": {get: operations["year_fond_retrieve"];};
  "/api/year/budgetreceivers/{id}": {get: operations["year_budgetreceivers_retrieve"];};
  "/api/year/budgets/{id}": {get: operations["year_budgets_retrieve"];};
};

export type webhooks = Record<string, never>;

export type components = {
  schemas: {
    Booking: {
      unique_id: string;
      /** Format: date */
      date: string;
      display_name: string;
      requester: string;
      link: string;
      status: components["schemas"]["Status"];
      /** Format: decimal */
      booked_total: string;
    };
    /**
     * @description * `1` - Net
     * * `2` - Gross 
     * @enum {integer}
     */
    BookingTypeEnum: 1 | 2;
    BudgetList: {
      /** ID */
      pk: number;
      requester: components["schemas"]["Requester"];
      /**
       * Zielvorgabe 
       * Format: decimal
       */
      target: string;
      name: string;
      /**
       * Erstellungsdatum 
       * Format: date
       */
      date: string;
      status: components["schemas"]["Status"];
    };
    BudgetParentList: {
      /** ID */
      pk: number;
      name: string;
    };
    BudgetReply: {
      /** ID */
      pk: number;
      name: string;
      parent?: number | null;
      requester: components["schemas"]["Requester"];
      request: components["schemas"]["Request"];
      /**
       * Zielvorgabe 
       * Format: decimal
       */
      target: string;
      /** Beschreibung */
      description?: string;
      /**
       * Erstellungsdatum 
       * Format: date
       */
      date: string;
      status: components["schemas"]["Status"];
    };
    BudgetRequest: {
      name: string;
      parent?: number | null;
      requester: number;
      /**
       * Zielvorgabe 
       * Format: decimal
       */
      target: string;
      /** Beschreibung */
      description?: string;
      request?: components["schemas"]["RequestRequest"];
    };
    BudgetUtilization: {
      name: string;
      labels: (string)[];
      relative_values: (string)[];
      absolute_values: (string)[];
    };
    ByStatus: {
      labels: (string)[];
      recent_values: (number)[];
      stale_values: (number)[];
      count_previous_year: number;
    };
    CreateSSOUserRequest: {
      sso_username: string;
      groups?: (components["schemas"]["GroupRequest"])[];
    };
    Fond: {
      pk: number;
      name: string;
      budgets: (components["schemas"]["YearBudgetReceiver"])[];
    };
    FondList: {
      /** ID */
      pk: number;
      name: string;
    };
    GroupRequest: {name: string;};
    Log: {
      /** Format: date-time */
      action_time: string;
      /** @default */
      user?: string;
      /** @default */
      name: string;
      /** @default #ABB5BE */
      color?: string;
      action: string;
      link: string;
      class_name: string;
    };
    Offer: {
      /** ID */
      pk: number;
      /** Bieter */
      bidder: string;
      /**
       * Nettopreis 
       * Format: decimal
       */
      net: string;
      /** Wunschangebot? */
      is_desired: boolean;
      /**
       * Angebot 
       * Format: uri
       */
      offer_file: string;
    };
    OfferRequest: {
      /** Bieter */
      bidder: string;
      /**
       * Nettopreis 
       * Format: decimal
       */
      net: string;
      /** Wunschangebot? */
      is_desired: boolean;
      offer_file: components["schemas"]["PDFBase64FileFieldRequest"];
    };
    PDFBase64FileFieldRequest: {
      name: string;
      data: string;
    };
    PatchedBudgetRequest: {
      name?: string;
      parent?: number | null;
      requester?: number;
      /**
       * Zielvorgabe 
       * Format: decimal
       */
      target?: string;
      /** Beschreibung */
      description?: string;
      request?: components["schemas"]["RequestRequest"];
    };
    PatchedOfferRequest: {
      /** Bieter */
      bidder?: string;
      /**
       * Nettopreis 
       * Format: decimal
       */
      net?: string;
      /** Wunschangebot? */
      is_desired?: boolean;
      offer_file?: components["schemas"]["PDFBase64FileFieldRequest"];
    };
    RecentInvoiceGrouped: {
      pk: number;
      name: string;
      items: (components["schemas"]["Booking"])[];
    };
    RecentRequest: {
      /** Format: date */
      date: string;
      display_name: string;
      status: components["schemas"]["Status"];
      requester: string;
      link: string;
      /** Format: decimal */
      booked_total: string;
    };
    RecentRequestGrouped: {
      pk: number;
      name: string;
      items: (components["schemas"]["RecentRequest"])[];
    };
    Request: {
      /** ID */
      pk: number;
      /** Grund */
      reason?: string;
      /**
       * Netto-Einzelpreis 
       * Format: decimal
       */
      net_single_amount?: string | null;
      /**
       * Belegdatei 
       * Format: uri
       */
      receipt?: string | null;
      offers: (components["schemas"]["Offer"])[];
    };
    RequestRequest: {
      /** Grund */
      reason?: string;
      /**
       * Netto-Einzelpreis 
       * Format: decimal
       */
      net_single_amount?: string | null;
      receipt?: components["schemas"]["PDFBase64FileFieldRequest"];
      offers?: (components["schemas"]["OfferRequest"])[];
    };
    Requester: {
      /** ID */
      pk: number;
      name: string;
      booking_type: components["schemas"]["BookingTypeEnum"];
    };
    Stats: {
      /** Format: date */
      sap: string;
      request_processing_time: number;
      budget_utilization: (components["schemas"]["BudgetUtilization"])[];
      invoices_by_status: components["schemas"]["ByStatus"];
      requests_by_status: components["schemas"]["ByStatus"];
    };
    Status: {
      /** Format: double */
      progress: number;
      text: string;
    };
    User: {
      /**
       * Benutzername 
       * @description Erforderlich. 150 Zeichen oder weniger. Nur Buchstaben, Ziffern und @/./+/-/_.
       */
      username: string;
      /** Vorname */
      first_name?: string;
      /** Nachname */
      last_name?: string;
      /**
       * Letzte Anmeldung 
       * Format: date-time
       */
      last_login?: string | null;
      /**
       * Mitglied seit 
       * Format: date-time
       */
      date_joined?: string;
      /**
       * Administrator-Status 
       * @description Legt fest, dass der Benutzer alle Berechtigungen hat, ohne diese einzeln zuweisen zu müssen.
       */
      is_superuser?: boolean;
    };
    WhoAmIResponse: {
      user: components["schemas"]["User"];
      debug_branding: string;
    };
    Year: {
      fonds: (components["schemas"]["FondList"])[];
      year: string;
    };
    YearBooking: {
      unique_id: string;
      /** Format: date */
      date: string;
      display_name: string;
      status: components["schemas"]["Status"];
      link: string;
      /** Format: decimal */
      booked_total: string;
    };
    YearBudget: {
      pk: number;
      name: string;
      description: string;
      status: components["schemas"]["Status"];
      /** Format: date */
      date: string;
      /** Format: decimal */
      actual: string;
      /** Format: decimal */
      expected: string;
      /** Format: decimal */
      target: string;
      has_request: boolean;
    };
    YearBudgetDetail: {
      bookings: (components["schemas"]["YearBooking"])[];
      budgets: (components["schemas"]["YearBudget"])[];
    };
    YearBudgetReceiver: {
      pk: number;
      name: string;
      requester: number;
      /** Format: decimal */
      actual: string;
      /** Format: decimal */
      expected: string;
      /** Format: decimal */
      target: string;
    };
    YearBudgetReceiverDetails: {
      bookings: (components["schemas"]["YearBooking"])[];
      budgets: (components["schemas"]["YearBudget"])[];
    };
  };
  responses: never;
  parameters: never;
  requestBodies: never;
  headers: never;
  pathItems: never;
};

export type external = Record<string, never>;

export type operations = {

  bookings_list: {
    parameters: {
      query: {
        /** @description Search Value */
        search: string;
      };
    };
    responses: {200: {content: {"application/json": (components["schemas"]["Booking"])[];};};};
  };
  bookings_recent_list: {
    parameters: {
      query?: {
        /** @description Number of Days ago until all logs are displayed */
        days?: string;
      };
    };
    responses: {200: {content: {"application/json": (components["schemas"]["RecentInvoiceGrouped"])[];};};};
  };
  bookings_stale_list: {responses: {200: {content: {"application/json": (components["schemas"]["RecentInvoiceGrouped"])[];};};};};
  budgets_list: {
    parameters: {
      query: {
        /** @description Nur Budgets mit Request anzeigen */
        requestsOnly: boolean;
      };
    };
    responses: {200: {content: {"application/json": (components["schemas"]["BudgetList"])[];};};};
  };
  budgets_create: {
    requestBody: {
      content: {
        "application/json": components["schemas"]["BudgetRequest"];
        "application/x-www-form-urlencoded": components["schemas"]["BudgetRequest"];
        "multipart/form-data": components["schemas"]["BudgetRequest"];
      };
    };
    responses: {200: {content: {"application/json": components["schemas"]["BudgetReply"];};};};
  };
  budgets_retrieve: {
    parameters: {
      path: {
        /** @description A unique integer value identifying this Budget. */
        id: number;
      };
    };
    responses: {200: {content: {"application/json": components["schemas"]["BudgetReply"];};};};
  };
  budgets_partial_update: {
    parameters: {
      path: {
        /** @description A unique integer value identifying this Budget. */
        id: number;
      };
    };
    requestBody?: {
      content: {
        "application/json": components["schemas"]["PatchedBudgetRequest"];
        "application/x-www-form-urlencoded": components["schemas"]["PatchedBudgetRequest"];
        "multipart/form-data": components["schemas"]["PatchedBudgetRequest"];
      };
    };
    responses: {200: {content: {"application/json": components["schemas"]["BudgetReply"];};};};
  };
  budgets_potential_parents_list: {
    parameters: {
      query: {
        /** @description Primary Key des Requesters */
        requester: number;
      };
    };
    responses: {200: {content: {"application/json": (components["schemas"]["BudgetParentList"])[];};};};
  };
  misc_logs_list: {
    parameters: {
      query?: {
        /** @description Number of Days ago from which all logs are displayed */
        from?: string;
        /** @description Number of Days ago until all logs are displayed */
        to?: string;
      };
    };
    responses: {200: {content: {"application/json": (components["schemas"]["Log"])[];};};};
  };
  misc_stats_retrieve: {responses: {200: {content: {"application/json": components["schemas"]["Stats"];};};};};
  offers_partial_update: {
    parameters: {path: {id: string;};};
    requestBody?: {
      content: {
        "application/json": components["schemas"]["PatchedOfferRequest"];
        "application/x-www-form-urlencoded": components["schemas"]["PatchedOfferRequest"];
        "multipart/form-data": components["schemas"]["PatchedOfferRequest"];
      };
    };
    responses: {200: {content: {"application/json": components["schemas"]["Offer"];};};};
  };
  requesters_list: {responses: {200: {content: {"application/json": (components["schemas"]["Requester"])[];};};};};
  requesters_retrieve: {
    parameters: {
      path: {
        /** @description A unique integer value identifying this Antragssteller. */
        id: number;
      };
    };
    responses: {200: {content: {"application/json": components["schemas"]["Requester"];};};};
  };
  requests_destroy: {
    parameters: {path: {id: string;};};
    responses: {
      /** @description No response body */
      204: never;
    };
  };
  requests_recent_list: {
    parameters: {
      query?: {
        /** @description Number of Days ago until all logs are displayed */
        days?: string;
      };
    };
    responses: {200: {content: {"application/json": (components["schemas"]["RecentRequestGrouped"])[];};};};
  };
  requests_stale_list: {responses: {200: {content: {"application/json": (components["schemas"]["RecentRequestGrouped"])[];};};};};
  /**
   * @description OpenApi3 schema for this API. Format can be selected via content negotiation.
   * 
   * - YAML: application/vnd.oai.openapi
   * - JSON: application/vnd.oai.openapi+json
   */
  schema_retrieve: {
    parameters: {
      query?: {
        format?: "json" | "yaml";
        lang?: "af" | "ar" | "ar-dz" | "ast" | "az" | "be" | "bg" | "bn" | "br" | "bs" | "ca" | "cs" | "cy" | "da" | "de" | "dsb" | "el" | "en" | "en-au" | "en-gb" | "eo" | "es" | "es-ar" | "es-co" | "es-mx" | "es-ni" | "es-ve" | "et" | "eu" | "fa" | "fi" | "fr" | "fy" | "ga" | "gd" | "gl" | "he" | "hi" | "hr" | "hsb" | "hu" | "hy" | "ia" | "id" | "ig" | "io" | "is" | "it" | "ja" | "ka" | "kab" | "kk" | "km" | "kn" | "ko" | "ky" | "lb" | "lt" | "lv" | "mk" | "ml" | "mn" | "mr" | "ms" | "my" | "nb" | "ne" | "nl" | "nn" | "os" | "pa" | "pl" | "pt" | "pt-br" | "ro" | "ru" | "sk" | "sl" | "sq" | "sr" | "sr-latn" | "sv" | "sw" | "ta" | "te" | "tg" | "th" | "tk" | "tr" | "tt" | "udm" | "uk" | "ur" | "uz" | "vi" | "zh-hans" | "zh-hant";
      };
    };
    responses: {
      200: {
        content: {
          "application/vnd.oai.openapi": {[key: string]: unknown;};
          "application/yaml": {[key: string]: unknown;};
          "application/vnd.oai.openapi+json": {[key: string]: unknown;};
          "application/json": {[key: string]: unknown;};
        };
      };
    };
  };
  users_new_sso_user_create: {
    requestBody: {
      content: {
        "application/json": components["schemas"]["CreateSSOUserRequest"];
        "application/x-www-form-urlencoded": components["schemas"]["CreateSSOUserRequest"];
        "multipart/form-data": components["schemas"]["CreateSSOUserRequest"];
      };
    };
    responses: {200: {content: {"application/json": components["schemas"]["User"];};};};
  };
  whoami_retrieve: {responses: {200: {content: {"application/json": components["schemas"]["WhoAmIResponse"];};};};};
  year_retrieve: {
    parameters: {
      path: {
        /** @description Jahr */
        year: string;
      };
    };
    responses: {200: {content: {"application/json": components["schemas"]["Year"];};};};
  };
  year_fond_retrieve: {
    parameters: {
      path: {
        id: string;
        /** @description Jahr */
        year: string;
      };
    };
    responses: {200: {content: {"application/json": components["schemas"]["Fond"];};};};
  };
  year_budgetreceivers_retrieve: {
    parameters: {path: {id: string;};};
    responses: {200: {content: {"application/json": components["schemas"]["YearBudgetReceiverDetails"];};};};
  };
  year_budgets_retrieve: {
    parameters: {path: {id: string;};};
    responses: {200: {content: {"application/json": components["schemas"]["YearBudgetDetail"];};};};
  };
};
